{
> I heard something in this echo about someone having Pascal source to view
> .PCX Files and I would appreciate if they would re-post the source if it's
> not too long or tell me where I can get it.  I am also looking For some
> good COMM routines For Pascal, anyone have any or no where I can get some?

The routine I have will only work With 320x200x256c images.

        For all those Pascal Programmers who just want something simple
        to display a 320x200x256 colour PCX File on the screen here it is.
        This was a direct translation from the C source code of PCXVIEW
        written by Lee Hamel (Patch), Avalanche coder.  I removed the
        Inline assembly code so that you beginners can see what was going
        on behind those routines.

Norman Yen - Infinite Dreams BBS - August 11, 1993
}

Unit PCXLoad;

interface

Uses vga256d,starfade;

Type
  pcxheader_rec = Record
    manufacturer   : Byte;
    version        : Byte;
    encoding       : Byte;
    bits_per_pixel : Byte;
    xmin, ymin     : Word;
    xmax, ymax     : Word;
    hres, vres     : Word;
    palette        : Array [0..47] of Byte;
    reserved       : Byte;
    colour_planes  : Byte;
    Bytes_per_line : Word;
    palette_Type   : Word;
  end;

Var
  Colors2 : ColorType;
  width,
  depth   : Word;
  Bytes   : Word;
  c,c2   : char;
  overrideblack : boolean;

procedure LoadPCX ( Name : string; storepalette : boolean );
procedure UpdatePCXColorsSlow(ColorBuffer : pointer);

implementation


procedure UpdatePCXColorsSlow(ColorBuffer : pointer); assembler;
asm
  cli
  push ds

  lds  si, ColorBuffer
  les  di, ColorBuffer
  mov  cx, 3*256

  mov  dx, 03C8h
  xor  al, al
  out  dx, al
  inc  dx
@ColorLoop:
  lodsb
  shr  al,1
  shr  al,1
  stosb
  loop @ColorLoop

  pop  ds
  sti
end;

procedure LoadPCX ( Name : string; storepalette : boolean );
var
  header  : pcxheader_rec;
  textbuf : array[1..1024] of char;
  fi      : file;
  PCXfile : text;


Procedure Unpack_PCX;
Label
  enddraw, whileloop, readonebyte;
Var
  c,c2 : char;
  temp,bytes,i : word;
begin
  temp:=header.bytes_per_line;
  asm
     sub di,di  (*CX Stores Video Offset*)
  end;

 for i:=1 to depth do begin

 bytes:=temp;
whileloop:
  asm
     push di
  end;

    read (PCXfile,c);
  asm
    pop di
    mov al,c
    and al,192
    cmp al,192
    jne readonebyte
    push di
  end;

    { if it's a run of Bytes field }

      { get the run Byte }
      read(PCXfile,c2);

      asm
         pop di
         sub cx,cx
         mov cl,c
         and cl,63

         sub bytes,cx                 (* Dec(r,run) *)

         mov es,VGAScreenSeg

         mov al,c2

         db $066
         rep stosb

         cmp bytes,0
         jne whileloop
         jmp enddraw

      readonebyte:

         mov es,VGAScreenSeg
         mov al,c

         mov es:[di],al
         inc di

         dec bytes
         jnz whileloop
      end;

enddraw:
  asm
     add di,320
     sub di,temp
  end;

 end;
end;


begin
    assign(fi, Name);
    reset(fi, 1);
    blockread (fi, header, sizeof(header));
    if (header.manufacturer = 10) and (header.version = 5) and
       (header.bits_per_pixel = 8) and (header.colour_planes = 1) then
    begin
      seek(fi, Filesize(fi) - 768);

      blockread(fi, colors2, 768);
      updatePCXcolorsslow( @colors2 );
      if storepalette then updatecolorsfast(@colors2) else
        if not overrideblack then updatecolorsfast(@black) else
           overrideblack:=false;
      colors:=colors2;

      close(fi);

      assign(PCXfile,name);
      settextbuf(PCXfile,textbuf);
      reset(PCXfile);

      for byte(c):=1 to 128 do read(PCXfile,c2);

      width := succ(header.xmax) - header.xmin;
      depth := succ(header.ymax) - header.ymin;
      Bytes := header.Bytes_per_line;
      Unpack_PCX;
      close(pcxfile);

    end;
end;

begin
   overrideblack:=false;
end.
