{
Eirik Milch Pedersen

> I too, would appreciate the source for fading colours in 16 colour text
> mode on a VGA, i've tried my hand at it but can't work out a decent
> algoritm, i've been using int 10h to set a block of colour regs for speed
> but can't seem to work out how to fade the colours!

I replyed to the author of the first fade-question, but I might as well post
my code to the public. This is a little demo I made in TP60 for fading form a
palette to another. So techincal you can fade from anything to anything. :-)
The routine should be fast enough for most computers, but if you start to
see 'snow' on the screen try to reduce the number of colors that are faded.
}
unit starfade;

(*{$G+}*)
interface

type
   ColorRec  = record   R,G,B:byte;  end;
   ColorType = array[0..255] of colorrec;

var
  Black,Colors,Colors2,DummyPalette,DummySub : colortype;
  NoColorsX3 : word;

{procedure UpdateColorsSlow(ColorBuffer : pointer);}
procedure UpdateColorsFast(ColorBuffer : pointer);
procedure FadeColors(FromColors, ToColors : Pointer;
                     StartCol, NoColors, NoSteps : byte);
procedure FadeBlack (steps:byte);
procedure FadeColor (steps:byte);
procedure FadeWhite (steps:byte);

implementation

procedure UpdateColorsFast(ColorBuffer : pointer); assembler;  {was SLOW}
asm
  mov  di,ds

  lds  si, ColorBuffer
  mov  cx, 3*256

  mov  dx, 03C8h
  xor  al, al
  out  dx, al
  inc  dx
@ColorLoop:                         { here is the substitute that }
  lodsb                             { goes round the problem.     }
  out  dx, al
  loop @ColorLoop

  mov  ds,di
end;

{procedure UpdateColorsFast(ColorBuffer : pointer); assembler;
asm
  cli
  mov  di,ds

  lds  si, ColorBuffer
  mov  cx, 3*256

  mov  dx, 03C8h
  xor  al, al
  out  dx, al
  inc  dx

  rep  outsb       (* here is the cause of the problem. *)

  mov  ds,di
  sti
end;}



procedure FadeColors(FromColors, ToColors : Pointer;
                     StartCol, NoColors, NoSteps : byte); assembler;
label
  StepLoop, ColorLoop, SubLoop, RetrLoop1, RetrLoop2, Over1, Over2;
asm
  lds         si, ToColors
  les         di, FromColors
  xor         ch, ch
  mov         cl, NoColors
  inc         cx
  shl         cx, 1
  add         cl, NoColors
  inc         cx
  adc         ch, 0
  mov         NoColorsX3,cx
  sub         bx, bx
  push        di

 SubLoop:
    lodsb
    sub         al, byte ptr es:di
    mov         byte ptr [DummySub+bx], al
    inc         di
    inc         bx
  loop SubLoop

  pop         di

  sub         dh,dh
  mov         dl, NoSteps
 StepLoop:
  push        di
  mov         cx, NoColorsX3
  sub         bx,bx
 ColorLoop:
  xor         ah, ah
  mov         al, byte ptr [DummySub+bx]
  or          al, al
  jns         over1
  neg         al
 over1:
  mul         dh
  div         dl
  cmp         byte ptr [DummySub+bx],0

  jge         over2
  neg         al
 over2:

  mov         ah, byte ptr es:[di]
  add         ah, al
  mov         byte ptr [DummyPalette+bx], ah
  inc         bx
  inc         di
  loop ColorLoop

  push        dx
  mov         si, offset DummyPalette

  mov         dx, 03DAh
 retrloop1:
  in          al, dx
  test        al, 8
  jnz         retrloop1
 retrloop2:
  in          al, dx
  test        al, 8
  jz          retrloop2

  mov         dx, 03C8h
  mov         al, StartCol
  out         dx, al
  inc         dx
  mov         cx, NoColorsX3

@ColorLoop:                         { here is the substitute that }
  lodsb                             { goes round the problem.     }
  out  dx, al
  loop @ColorLoop

(*  rep         outsb     { 286 Instruction }*)

  pop         dx
  pop         di

  inc         dh
  cmp         dh, dl
  jbe         StepLoop
end;


procedure FadeBlack (steps:byte);
begin
FadeColors(@colors,@black,0,255,steps);
end;

procedure FadeColor (steps:byte);
begin
FadeColors(@black,@colors,0,255,steps);
end;

procedure FadeWhite (steps:byte);
begin
FillChar(Black, 256 * 3, 63);
FadeColors(@colors,@black,0,255,steps);
colors:=black;
FillChar(Black, 256 * 3, 0);
end;


begin
FillChar(Black, 256 * 3, 0);
END.
