unit pallib;

interface

uses
   starfade;

const
   maxpal = 23;

type
   paltype = array[1..maxpal] of colortype;
var
   palettes : ^paltype;
   palnum : word;

procedure loadpals;
procedure ZPal (palette : byte);

implementation

procedure loadpals;
var f:file of colortype;
    tempstr : string[30];
begin
palnum:=0;

assign(f,'PALETTE.DAT');
reset(f);
while not eof(f) do begin
inc(palnum);
read(f,palettes^[palnum]);
end;

close(f);

end;

procedure ZPal (palette : byte);
begin
   updatecolorsfast(@palettes^[palette]);
end;


begin
   new(palettes);
   loadpals;
end.